#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <cstring>
#include <map>
#include "SDL.h"

using namespace std;

#include "cEnviroMan.h"
#include "Utils.h"
#include "ScreenUtilities.h"
#include "ImageIO.h"


#include "SDL_gfxPrimitives.h"

EnviroMan::~EnviroMan(){};

void EnviroMan::playLevel(SDL_Surface* screen, int time,SDL_Surface* charact,SDL_Surface* end_portal,SDL_Surface* bonus_blue,SDL_Surface* bonus_orange,SDL_Surface* bonus_red,SDL_Surface* bonus_green,SDL_Surface* enemy1,SDL_Surface* enemy2,SDL_Surface* enemy3)
{
  Utils ut; 
  SDL_Event event;
     
  if ((time % 13) == 0 )
  {
            
     for (int j = 0; j<lilyX; j++)
     {
             for (int i = 0; i<lilyY; i++)
             {
                 if ( wl[i][j].getActive() )
                 {
                      if ( wl[i][j].getRB() - sub > 2 )
                      {
                      
                           if (i != 0 || j != lilyX-1)
                           {
                              wl[i][j].setRA(wl[i][j].getRA()-sub);
                              wl[i][j].setRB(wl[i][j].getRB()-sub);
                           }
                           filledEllipseRGBA(screen,wl[i][j].getX(),wl[i][j].getY(),wl[i][j].getRA(),wl[i][j].getRB(), LILY_R , LILY_G , LILY_B , LILY_A);
                           ellipseRGBA(screen,wl[i][j].getX(),wl[i][j].getY(),wl[i][j].getRA(),wl[i][j].getRB(),0,0,0,255);
                           
                      }
                      else
                      {
                          wl[i][j].setActive(false);
                          if ( level>0 && level<=5 )
                             wl[i][j].setWait(int(float(rand()%10)));
                          else if ( level>5 && level<=10 )
                             wl[i][j].setWait(int(float(rand()%12)));
                      }
                 }
                 else
                 {
                     if ( wl[i][j].getWait( ) - 1 >= 0 )
                     {
                          wl[i][j].setWait(wl[i][j].getWait()- 1);
                     }
                     else
                     {
                           wl[i][j].setActive(true);
                           wl[i][j].setRA(wl[i][j].getMaxRA());
                           wl[i][j].setRB(wl[i][j].getMaxRB());
                     
                     }
                 }
             }
       }
     
       wl[0][lilyX-1].setRA(wl[0][lilyX-1].getMaxRA());
       wl[0][lilyX-1].setRB(wl[0][lilyX-1].getMaxRB());
         
     }
     else
     {
        for (int j = 0; j<lilyX; j++)
        {
             for (int i = 0; i<lilyY; i++)
             {
                 if (wl[i][j].getActive())
                 {
                          filledEllipseRGBA(screen,wl[i][j].getX(),wl[i][j].getY(),wl[i][j].getRA(),wl[i][j].getRB(), LILY_R , LILY_G , LILY_B , LILY_A);
                          ellipseRGBA(screen,wl[i][j].getX(),wl[i][j].getY(),wl[i][j].getRA(),wl[i][j].getRB(),0,0,0,255);
                 }
             }
         }
      }
      
      // vykreslovanie bonusov + kolizia s hracom
         for (int j = 0; j<10; j++)
         {
           int bonusX = bonus[j].getX();
           int bonusY = bonus[j].getY();
           
           if (bonus[j].getWait() > 0 && !bonus[j].getActive())
           {   bonus[j].setWait(bonus[j].getWait()-1);  }
           else
           {
               if ( bonus[j].getActive() == false )
               {
                    int a;
                    int b;            
                    bool q = false;
                    
                    do 
                    {
                        b = int(float(rand()%lilyX));
                        a = int(float(rand()%lilyY));
                        
                        if (wl[a][b].getActive()==false) q = false; else q=true;
                        if (a==lilyY-1 && b==0) q = false; else q=true;
                        if (a==0 && b==lilyX-1) q = false; else q=true;
                                
                    }while ( q != true );
                    
                    bonus[j].setWait(0);
                    bonus[j].setActive(true);
                    bonus[j].setX(b);
                    bonus[j].setY(a);
               }
           } 
           
           bonusX = bonus[j].getX();
           bonusY = bonus[j].getY();
           
           if ( wl[bonusY][bonusX].getActive() == false )
           {
                bonus[j].setActive(false);
                
                if (bonus[j].getType() == 0 || bonus[j].getType() == 1)
                   bonus[j].setWait(int(float(rand()%120)));
                else
                    bonus[j].setWait(int(float(rand()%300)));
           
           }
           
           if ( bonusY == pY && bonusX == pX && bonus[j].getActive()==true && bonus[j].getUnlocked()==true )
           {
                bonus[j].setActive(false);
                bonus[j].setWait(int(float(rand()%120)));
                
                if (bonus[j].getType() == 0) score += 90+10*level;
                if (bonus[j].getType() == 1) score -= 350;
                if (bonus[j].getType() == 2) lifes += 1;
                if (bonus[j].getType() == 3) 
                                             {
                                                   if (enemy[0].getUnlocked() && enemy[0].getActive())
                                                   {
                                                      enemy[0].setY(0);
                                                      enemy[0].setX(lilyX-1);
                                                      enemy[0].setActive(false);
                                                      enemy[0].setWait(int(float(rand()%125)));                   
                                                   }
                                                   else if (enemy[1].getUnlocked() && enemy[1].getActive())
                                                   {
                                                      enemy[1].setY(0);
                                                      enemy[1].setX(lilyX-1);
                                                      enemy[1].setActive(false);
                                                      enemy[1].setWait(int(float(rand()%125)));                   
                                                   }
                                                   else if (enemy[2].getUnlocked() && enemy[2].getActive())
                                                   {
                                                      enemy[2].setY(0);
                                                      enemy[2].setX(lilyX-1);
                                                      enemy[2].setActive(false);
                                                      enemy[2].setWait(int(float(rand()%125)));
                                                   }                                                   
                                             }
           }
           
           if (bonus[j].getUnlocked() && bonus[j].getActive() )
              switch (bonus[j].getType())
              {
                     case 0 :
                                   utils.drawSprite(bonus_blue,screen,0,0,offX+bonusX*dX-8,offY+bonusY*dY-15,bonus_blue->w,bonus_blue->h);
                                   break;
                     case 1 : 
                                   utils.drawSprite(bonus_orange,screen,0,0,offX+bonusX*dX-8,offY+bonusY*dY-15,bonus_blue->w,bonus_blue->h);
                                   break;
                     case 2 : 
                                   utils.drawSprite(bonus_red,screen,0,0,offX+bonusX*dX-8,offY+bonusY*dY-15,bonus_blue->w,bonus_blue->h);
                                   break;
                     case 3 : 
                                   utils.drawSprite(bonus_green,screen,0,0,offX+bonusX*dX-8,offY+bonusY*dY-15,bonus_blue->w,bonus_blue->h);
                                   break;
              }
         }

         // zmen relativnu polohu hraca na absolutnu a vykresli ho + portal
         utils.drawSprite(end_portal,screen,0,0,wl[0][lilyX-1].getX()-13,wl[0][lilyX-1].getY()-45,end_portal->w,end_portal->h); 
         utils.drawSprite(charact,screen,0,0,offX+pX*dX-5,offY+pY*dY-15,charact->w,charact->h);
         
         // aktivacia nepriatelov
         for (int i=0; i<3;i++)
         {             
             if (enemy[i].getUnlocked())
             {
                 int eX = enemy[i].getX();
                 int eY = enemy[i].getY();
             
                 if (wl[eY][eX].getActive() == false )
                 {
                     enemy[i].setY(0);
                     enemy[i].setX(lilyX-1);
                     enemy[i].setActive(false);
                     enemy[i].setWait(int(float(rand()%125)));
                 }
                 if (enemy[i].getWait() > 0 && !enemy[i].getActive())
                       enemy[i].setWait(enemy[i].getWait()-1);
                 else if (enemy[i].getWait() == 0 && !enemy[i].getActive())
                 {
                       enemy[i].setActive(true);
                       enemy[i].setX(lilyX-1);
                       enemy[i].setY(0);
                       enemy[i].setWait(0);
                 }
                      
                 if (enemy[i].getActive())
                 {
                      switch (i)
                      {
                             case 0 : 
                                     utils.drawSprite(enemy1,screen,0,0,offX+eX*dX-5,offY+eY*dY-15,enemy1->w,enemy1->h);
                                     break;
                             case 1 : 
                                     utils.drawSprite(enemy2,screen,0,0,offX+eX*dX-5,offY+eY*dY-15,enemy2->w,enemy2->h);
                                     break;
                             case 2 : 
                                     utils.drawSprite(enemy3,screen,0,0,offX+eX*dX-5,offY+eY*dY-15,enemy3->w,enemy3->h);
                                     break;
                      }
                 }
             }
         }
    	 SDL_Flip(screen);
 
     // skontroluj ci nie sme vo vode + ci nekolidujeme s niektorym nepriatelom
     
     if (!wl[pY][pX].getActive())
     {
        if (lifes -1 >= 0)
        {
                  /*
                  lifes -= 1;                               
                  wl[lilyY-1][0].setRA(wl[lilyY-1][0].getMaxRA());
                  wl[lilyY-1][0].setRB(wl[lilyY-1][0].getMaxRB());
                  wl[lilyY-1][0].setWait(0);
                  wl[lilyY-1][0].setActive(true);
                  pX = 0;
                  pY = lilyY-1;
                  SDL_Delay(3000);
                  while ( SDL_PollEvent(&event)){}
                  */
                  int sc_temp = score;
                  int li_temp = lifes-1;
                  prepareLevel(level);
                  score = sc_temp;
                  lifes = li_temp;
                  SDL_Delay(3000);
                  while ( SDL_PollEvent(&event)){}
        }
        else
        {
                  prepareLevel(-1);
        }
    
     }
     for (int i=0;i<3;i++)
     {
       if (enemy[i].getActive() && enemy[i].getUnlocked())  
       {
         if ( enemy[i].getX()==pX && enemy[i].getY()==pY )
         {
            if (lifes -1 >= 0)
            {
                      lifes -= 1;                               
                      wl[lilyY-1][0].setRA(wl[lilyY-1][0].getMaxRA());
                      wl[lilyY-1][0].setRB(wl[lilyY-1][0].getMaxRB());
                      wl[lilyY-1][0].setWait(0);
                      wl[lilyY-1][0].setActive(true);
                      enemy[i].setY(0);
                      enemy[i].setX(lilyX-1);
                      enemy[i].setActive(false);
                      enemy[i].setWait(int(float(rand()%125)));
                      pX = 0;
                      pY = lilyY-1;
                      SDL_Delay(3000);
                      while ( SDL_PollEvent(&event)){}
            }
            else
            {
                      prepareLevel(-1);
            }
         }
       }
     }
     
     // skontroluj ci nie sme v portale
     if ((pX == lilyX-1)&& (pY==0))
     {
             SDL_Delay(3000);
             while ( SDL_PollEvent(&event)){}
             prepareLevel(level+1);
             score += 500;
     }
}

void EnviroMan::prepareLevel(int l)
{
    setLevel(l);
    
    if (l == 1)
    {
          score =0; lifes = 3;
    }
    
    if ( level>0 && level<=5 )
    {
         lilyX = 5;
         lilyY = 4;
         pX = 0;
         pY = lilyY-1;
         sub = 2;
         offX = 32;
         offY = 65;
         dX = 65;
         dY = 50;
         
         // generovanie vsetkych lekien
         for (int j = 0; j<lilyX; j++)
         {
             for (int i = 0; i<lilyY; i++)
             {
                 wl[i][j].setMaxRA(28);
                 wl[i][j].setMaxRB(24);
                 
                 wl[i][j].setRA(wl[i][j].getMaxRA());
                 wl[i][j].setRB(wl[i][j].getMaxRB());
                 
                 wl[i][j].setActive(true);
                 
                 wl[i][j].setX(j*dX+offX);
                 wl[i][j].setY(i*dY+offY);
                 
                 wl[i][j].setWait(0);
             }
         }
         
         // generovanie lekien ktore zacnu inak         
         for (int j = 0; j<15; j++)
         {
            int a = int(float(rand()%lilyY));
            int b = int(float(rand()%lilyX));
            
            int c = int(float(rand()%20));
            wl[a][b].setRA(c);
            wl[a][b].setRB(c-sub);
            
            if (c<8)
            {
                 wl[a][b].setActive(false);
                 wl[a][b].setWait(int(float(rand()%40)));
            }
            
         }
         // lekno pod hracom
         wl[pY][pX].setActive(true);
         wl[pY][pX].setRA(28);
         wl[pY][pX].setRB(24);
         
         // lekno s portalom
         wl[0][lilyX-1].setActive(true);
         wl[0][lilyX-1].setRA(28);
         wl[0][lilyX-1].setRB(24);        
         
         // aktivne bonusy
         for (int j = 0; j<level; j++)
         {
            int a;
            int b;            
            bool q = false;
            
            do 
            {
                b = int(float(rand()%lilyX));
                a = int(float(rand()%lilyY));
                
                if (wl[a][b].getActive()==false) q = false; else q=true;
                if (a==lilyY-1 && b==0) q = false; else q=true;
                if (a==0 && b==lilyX-1) q = false; else q=true;
                        
            }while ( q != true );
            
            bonus[j].setUnlocked(true);
            bonus[j].setType(0);
            bonus[j].setActive(true);
            bonus[j].setWait(0);
            bonus[j].setX(b);
            bonus[j].setY(a);
         }
         // zvysne bonusy
         for (int j = level; j<10; j++)
             bonus[j].setUnlocked(false);
         
         enemy[2].setUnlocked(false);
         enemy[1].setUnlocked(false);
         enemy[0].setUnlocked(false);
    }
    else if ( level>5 && level<=10 )
    {
         lilyX = 6;
         lilyY = 5;
         pX = 0;
         pY = lilyY-1;
         sub = 1;
         offX = 25;
         offY = 55;
         dX = 53;
         dY = 40;
         
         // generovanie vsetkych lekien
         for (int j = 0; j<lilyX; j++)
         {
             for (int i = 0; i<lilyY; i++)
             {
                 wl[i][j].setMaxRA(23);
                 wl[i][j].setMaxRB(19);
                 
                 wl[i][j].setRA(wl[i][j].getMaxRA());
                 wl[i][j].setRB(wl[i][j].getMaxRB());
                 
                 wl[i][j].setActive(true);
                 
                 wl[i][j].setX(j*dX+offX);
                 wl[i][j].setY(i*dY+offY);
                 
                 wl[i][j].setWait(0);
             }
         }
         
         // generovanie lekien ktore zacnu inak         
         for (int j = 0; j<15; j++)
         {
            int a = int(float(rand()%lilyY));
            int b = int(float(rand()%lilyX));
            
            int c = int(float(rand()%18));
            wl[a][b].setRA(c);
            wl[a][b].setRB(c-sub);
            
            if (c<8)
            {
                 wl[a][b].setActive(false);
                 wl[a][b].setWait(int(float(rand()%40)));
            }
            
         }
         // lekno pod hracom
         wl[pY][pX].setActive(true);
         wl[pY][pX].setRA(28);
         wl[pY][pX].setRB(24);
         
         // lekno s portalom
         wl[0][lilyX-1].setActive(true);
         wl[0][lilyX-1].setRA(28);
         wl[0][lilyX-1].setRB(24);        
         
         // aktivne bonusy
         for (int j = 0; j<8; j++)
         {
            int a;
            int b;            
            bool q = false;
            
            do 
            {
                b = int(float(rand()%lilyX));
                a = int(float(rand()%lilyY));
                
                if (wl[a][b].getActive()==false) q = false; else q=true;
                if (a==lilyY-1 && b==0) q = false; else q=true;
                if (a==0 && b==lilyX-1) q = false; else q=true;
                        
            }while ( q != true );
            
            bonus[j].setUnlocked(true);
            
            if  (j>0 && j<=5)
               bonus[j].setType(0);
            else
               bonus[j].setType(1);  
                
            bonus[j].setActive(true);
            bonus[j].setWait(0);
            bonus[j].setX(b);
            bonus[j].setY(a);
         }
         // zvysne bonusy
         for (int j = level; j<10; j++)
             bonus[j].setUnlocked(false);
             
         enemy[2].setUnlocked(false);
         enemy[1].setUnlocked(false);
         enemy[0].setUnlocked(true);
         enemy[0].setActive(true);
         enemy[0].setX(lilyX-1);
         enemy[0].setY(0);
    } 
    else if ( level>10 && level<=15 )
    {
         lilyX = 8;
         lilyY = 6;
         pX = 0;
         pY = lilyY-1;
         sub = 1;
         offX = 15;
         offY = 50;
         dX = 38;
         dY = 35;
         
         // generovanie vsetkych lekien
         for (int j = 0; j<lilyX; j++)
         {
             for (int i = 0; i<lilyY; i++)
             {
                 wl[i][j].setMaxRA(19);
                 wl[i][j].setMaxRB(15);
                 
                 wl[i][j].setRA(wl[i][j].getMaxRA());
                 wl[i][j].setRB(wl[i][j].getMaxRB());
                 
                 wl[i][j].setActive(true);
                 
                 wl[i][j].setX(j*dX+offX);
                 wl[i][j].setY(i*dY+offY);
                 
                 wl[i][j].setWait(0);
             }
         }
         
         // generovanie lekien ktore zacnu inak         
         for (int j = 0; j<35; j++)
         {
            int a = int(float(rand()%lilyY));
            int b = int(float(rand()%lilyX));
            
            int c = int(float(rand()%18));
            wl[a][b].setRA(c);
            wl[a][b].setRB(c-sub);
            
            if (c<8)
            {
                 wl[a][b].setActive(false);
                 wl[a][b].setWait(int(float(rand()%40)));
            }
            
         }
         // lekno pod hracom
         wl[pY][pX].setActive(true);
         wl[pY][pX].setRA(19);
         wl[pY][pX].setRB(15);
         
         // lekno s portalom
         wl[0][lilyX-1].setActive(true);
         wl[0][lilyX-1].setRA(19);
         wl[0][lilyX-1].setRB(15);        
         
         // aktivne bonusy
         for (int j = 0; j<=12; j++)
         {
            int a;
            int b;            
            bool q = false;
            
            do 
            {
                b = int(float(rand()%lilyX));
                a = int(float(rand()%lilyY));
                
                if (wl[a][b].getActive()==false) q = false; else q=true;
                if (a==lilyY-1 && b==0) q = false; else q=true;
                if (a==0 && b==lilyX-1) q = false; else q=true;
                        
            }while ( q != true );
            
            bonus[j].setUnlocked(true);
            
            if  (j>=0 && j<=5)
               bonus[j].setType(0);
               
            else if (j>5 && j<=10)
               bonus[j].setType(1);  
               
            else if (j==11)
               bonus[j].setType(2);
               
            else if (j==12)
               bonus[j].setType(3);         
               
            bonus[j].setActive(true);
            bonus[j].setWait(0);
            bonus[j].setX(b);
            bonus[j].setY(a);
         }
         // zvysne bonusy
         /*for (int j = level; j<10; j++)
             bonus[j].setUnlocked(false);
         */    
         enemy[2].setUnlocked(false);
         
         enemy[1].setUnlocked(true);
         enemy[1].setActive(false);
         enemy[1].setWait(100);
         enemy[1].setX(lilyX-1);
         enemy[1].setY(0);
         
         enemy[0].setUnlocked(true);
         enemy[0].setActive(true);
         enemy[0].setX(lilyX-1);
         enemy[0].setY(0);
    } 
    else
    {
        game = false;
    }
}
void EnviroMan::movePlayer(char os, bool direction)
{
     if ( os == 'X' )
     {
          if ( direction )  // X++
          {
               if ( pX +1 <= lilyX - 1  )
                 pX +=1;
          }
          else              // X--
          {
              if ( pX -1 >= 0  )
                 pX -=1;
          }
     }
     else if ( os == 'Y' )
     {
          if ( direction )  // Y++
          {
              if ( pY +1 <= lilyY - 1  )
                 pY +=1;
          
          }
          else              // Y--
          {
              if ( pY -1 >= 0  )
                 pY -=1;
          }
     }
}

void EnviroMan::moveEnemy(int time)
{    
     int e_reaction;
     int size;
     
     if ( level <= 10 ) e_reaction = 13; else e_reaction = 8; 
     if ( level <= 10 ) size = 6; else size = 2; 
     
      
     for (int i=0; i<3; i++)
     {
         if (time%e_reaction == 0)
         {
             int eY = enemy[i].getY();
             int eX = enemy[i].getX();
             
             if (wl[eY][eX].getRA() < size+2)
             {
                 int siz = 0;
                 int dir = 0;
                 
                 if ( eX-1 >=0 &&  wl[eY][eX-1].getRA() > siz && wl[eY][eX-1].getActive()) { siz = wl[eY][eX-1].getRA(); dir = 1;}
                 if ( eX+1 < lilyX &&  wl[eY][eX+1].getRA() > siz && wl[eY][eX+1].getActive() ) { siz = wl[eY][eX+1].getRA(); dir = 2;}
                 if ( eY-1 >=0 &&  wl[eY-1][eX].getRA() > siz && wl[eY-1][eX].getActive() ) { siz = wl[eY-1][eX].getRA(); dir = 3;}
                 if ( eY+1 < lilyY &&  wl[eY+1][eX].getRA() > siz && wl[eY+1][eX].getActive() ) { siz = wl[eY+1][eX].getRA(); dir = 4;}
                 
                 switch (dir)
                 {
                        case 1 : 
                                    enemy[i].setX(enemy[i].getX()-1);
                                    break;
                        case 2 : 
                                    enemy[i].setX(enemy[i].getX()+1);             
                                    break;
                        case 3 : 
                                    enemy[i].setY(enemy[i].getY()-1);
                                    break;
                        case 4 : 
                                    enemy[i].setY(enemy[i].getY()+1);
                                    break;
                 }
                 continue;
             
             
             }
             
             
             if (pX<enemy[i].getX())
             {
                 if (wl[eY][eX-1].getActive() && wl[eY][eX-1].getRA() > size)
                 {
                    enemy[i].setX(enemy[i].getX()-1);
                    continue;
                 }
             }

             if (pX>enemy[i].getX())
             {
                 if (wl[eY][eX+1].getActive() && wl[eY][eX+1].getRA() > size)
                 {
                    enemy[i].setX(enemy[i].getX()+1);             
                    continue;
                 }
             }
             
             if (pY<enemy[i].getY())
             {
                 if (wl[eY-1][eX].getActive() && wl[eY-1][eX].getRA() > size)
                 {
                    enemy[i].setY(enemy[i].getY()-1);
                    continue;
                 }
             }
              
             if (pY>enemy[i].getY())
             {
                if (wl[eY+1][eX].getActive() && wl[eY+1][eX].getRA() > size)
                {
                    enemy[i].setY(enemy[i].getY()+1);
                    continue;
                }
             }
         }
     }
}
void EnviroMan::drawStats(SDL_Surface* screen)
{
     Utils ut;
     char temp[6];
     
     ut.itoa(level,temp,10);
     screen = utils.drawText(screen,"Level : ",20,10);
     
     screen = utils.drawText(screen,temp,80,10);
     
     ut.itoa(lifes,temp,10);
     screen = utils.drawText(screen,"Lives : ",125,10);
     
     screen = utils.drawText(screen,temp,195,10);
     
     ut.itoa(score,temp,10);
     screen = utils.drawText(screen,"Score : ",20,20);
     screen = utils.drawText(screen,temp,80,20);
}

int EnviroMan::mainMenu()
{
     SDL_Event event;
     int done = 0;
     
     while (!done)
     {
         while ( SDL_PollEvent(&event))
            { 
            
        		switch (event.type)
        		{
                    case SDL_KEYDOWN:
                         
    					if (event.key.keysym.sym == SDLK_ESCAPE)
    						return 0;
    						
    					if (event.key.keysym.sym == SDLK_SPACE)
    						return 1;
    					break;
        
        			case SDL_JOYBUTTONDOWN:
                         switch(event.jbutton.button)
                         {
            				case GP2X_BUTTON_START:
                				return 1;
                				break;
                				
            				case GP2X_BUTTON_SELECT:
        						return 0;
        						break;
    					
        			    }break;				
                 }
            }
    }
}

void EnviroMan::chooseYourName(SDL_Surface* screen)
{
     SDL_Event event;
     int done = 0;
     ImageIO iio;
     SDL_Surface* menu = iio.loadImage(MENU2_PATH);
     int znak[3];
     znak[0]=znak[1]=znak[2]=65;
     int akt=0;
     SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY, SDL_DEFAULT_REPEAT_INTERVAL);
     while (!done)
     {
         utils.drawSprite(menu,screen,0,0,0,0,menu->w,menu->h);           
         
         while ( SDL_PollEvent(&event))
         { 
         		switch (event.type)
         		{
                    case SDL_KEYDOWN:

        					if (event.key.keysym.sym == SDLK_SPACE)
        					{
                                name[0] = char(znak[0]);
                                name[1] = char(znak[1]);
                                name[2] = char(znak[2]);
                                name[3] = '\0';
        						done=1;
                            }
                         
        					if (event.key.keysym.sym == SDLK_UP && znak[akt] + 1 <=128 )
        						znak[akt] += 1;
        						
        					if (event.key.keysym.sym == SDLK_DOWN && znak[akt] - 1 >= 0 )
        						znak[akt] -= 1;
        		            
           					if (event.key.keysym.sym == SDLK_LEFT && akt - 1 >= 0 )
        						akt -= 1;
        						
        					if (event.key.keysym.sym == SDLK_RIGHT && akt + 1 <= 2 )
        						akt += 1;
        						
   					        break;
   					        
        			case SDL_JOYBUTTONDOWN:
                         switch(event.jbutton.button)
                         { 
                         
            				case GP2X_BUTTON_X:
                                name[0] = char(znak[0]);
                                name[1] = char(znak[1]);
                                name[2] = char(znak[2]);
                                name[3] = '\0';
        						done=1;
        						break;
                            
                			case GP2X_BUTTON_UP:	
        					     if (znak[akt] + 1 <=128 )
        						    znak[akt] += 1;
    						     break;
    						     
        					case GP2X_BUTTON_DOWN:	
        					     if (znak[akt] - 1 >= 0 )
        						    znak[akt] -= 1;
        						 break;   
        						 
        		            case GP2X_BUTTON_LEFT:
           					     if (akt - 1 >= 0 )
        						    akt -= 1;
        						 break;   
        					
                            case GP2X_BUTTON_RIGHT: 	
        					     if (akt + 1 <= 2 )
        						    akt += 1;
            			         break;
                         }
                         break;  
                 }
         }
         
         char* p;
         char r[2];
         r[0] = char(znak[0]);
         r[1] = '\0';
         p=&r[0];
         utils.drawText(screen,p,60,130);
         
         r[0] = char(znak[1]);
         utils.drawText(screen,p,80,130);
         
         r[0] = char(znak[2]);
         utils.drawText(screen,p,100,130);
         
         if (akt == 0)
         {
             r[0] = '[';
             utils.drawText(screen,p,50,130);
             r[0] = ']';
             utils.drawText(screen,p,70,130);
                      
         }
         else if (akt == 1)
         {
             r[0] = '[';
             utils.drawText(screen,p,70,130);
             r[0] = ']';
             utils.drawText(screen,p,90,130);
         }
         else
         {
             r[0] = '[';
             utils.drawText(screen,p,90,130);
             r[0] = ']';
             utils.drawText(screen,p,110,130);
         }

         SDL_Flip(screen);
         SDL_Delay(80);
    }
}
