#ifndef _SCREENUTILITIES_H_
#define _SCREENUTILITIES_H_

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <cstring>
#include <fcntl.h>


using namespace std;


class ScreenUtilities
{
	public:
			void drawSprite(SDL_Surface* imageSurface, SDL_Surface* screenSurface, int srcX, int srcY, int dstX, int dstY, int width, int height);
			void PutPixel(SDL_Surface *surface, int x, int y, Uint32 pixel);
			Uint32 GetPixel(SDL_Surface *surface, int x, int y);
			int lock(SDL_Surface* surface);
			void unlock(SDL_Surface* surface);
			void SaveScreenshot(SDL_Surface *screen);
            void decode_rgb(SDL_Surface* screen, int rgb, int *red, int *green, int *blue);
            SDL_Surface* drawText(SDL_Surface* imageSurface, char* mytext,int X, int Y);
			

};

#endif

