#ifndef _CENVIROMAN_H_
#define _CENVIROMAN_H_

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <cstring>
#include <map>

using namespace std;

#include "cWaterLily.h"
#include "ScreenUtilities.h"
#include "ImageIO.h"
#include "consts.h"
#include "cBonus.h"
#include "cEnemy.h"

class EnviroMan
{
	private:
			int level; // aktualna uroven
			int pX;    // pozicia hraca
			int pY;
			
			int lilyX; // pocet lekien v danej urovni
			int lilyY; // pocet lekien v danej urovni
			
			int sub;   // o kolko sa lekna zmensuju
			
			int offX;  // posun lekien s offsetom na danej obrazovke
			int offY;
			
			int dX;
			int dY;
			
			bool game;
			
			int lifes;
			int score;
			char name[4];
			
			waterLily wl [30][20];
			Bonus bonus[15];
			Enemy enemy[3];
			ScreenUtilities utils;
			
		
			
	public:
			EnviroMan ()
            {
                
                level=1;
                pX = 0;
                pY = 3;     
                lilyX = 0;
                lilyY = 0;
                sub = 1;
                game = false;
                lifes = 3;
                score = 0; 
                name[0]='\0';
                 
            }
            
			~EnviroMan();
			
			void prepareLevel(int l);
			void playLevel(SDL_Surface*,int,SDL_Surface*,SDL_Surface*,SDL_Surface*,SDL_Surface*,SDL_Surface*,SDL_Surface*,SDL_Surface*,SDL_Surface*,SDL_Surface*);
			void movePlayer(char,bool);
			void moveEnemy(int);
			void drawStats(SDL_Surface* screen);
			int mainMenu();
            void chooseYourName(SDL_Surface*);
			
			int getLevel(){return level;}
			void setLevel(int lvl){level=lvl;}
			int getScore(){return score;}
			void setScore(int lvl){score=lvl;}
			bool getState(){return game;}
			void setState(bool state){game=state;}
			char* getName(){return &name[0];}
			
};

#endif
