#ifndef _CONSTS_H_
#define _CONSTS_H_

#define GP2X_BUTTON_UP              0
#define GP2X_BUTTON_DOWN            4
#define GP2X_BUTTON_LEFT            2
#define GP2X_BUTTON_RIGHT           6
#define GP2X_BUTTON_UPLEFT          1
#define GP2X_BUTTON_UPRIGHT         7
#define GP2X_BUTTON_DOWNLEFT        3
#define GP2X_BUTTON_DOWNRIGHT       5
#define GP2X_BUTTON_CLICK           18
#define GP2X_BUTTON_A               12
#define GP2X_BUTTON_B               13
#define GP2X_BUTTON_X               14
#define GP2X_BUTTON_Y               15
#define GP2X_BUTTON_L               10
#define GP2X_BUTTON_R               11
#define GP2X_BUTTON_START           8
#define GP2X_BUTTON_SELECT          9
#define GP2X_BUTTON_VOLUP           16
#define GP2X_BUTTON_VOLDOWN         17

#define LILY_R   200
#define LILY_G   115
#define LILY_B   30
#define LILY_A   255


#define FONT_PATH       "Fonts/5x7.fnt"
#define CHAR_PATH       "Images/char.png"
#define PATH_BACKGROUND "Images/image.jpg"
#define ENDPORTAL_PATH  "Images/portal.png"
#define BBONUS_PATH     "Images/bbonus.png"
#define OBONUS_PATH     "Images/obonus.png"
#define RBONUS_PATH     "Images/rbonus.png"
#define GBONUS_PATH     "Images/gbonus.png"
#define ENEMY1_PATH     "Images/enemy1.png"
#define ENEMY2_PATH     "Images/enemy2.png"
#define ENEMY3_PATH     "Images/enemy3.png"
#define INTRO_PATH      "Images/intro.png"
#define MENU_PATH       "Images/menu.png"
#define MENU2_PATH      "Images/menu2.jpg"
#define HISCORE_PATH    "data.dat"
#define NAME_PATH       "Images/namescreen.png"


#endif
